Package weka.filters.unsupervised.attribute

# Class RemoveType

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.RemoveType

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `RevisionHandler`, `WeightedAttributesHandler`, `WeightedInstancesHandler`, `StreamableFilter`, `UnsupervisedFilter`

public class RemoveType extends Filter implements UnsupervisedFilter, StreamableFilter, OptionHandler, WeightedAttributesHandler, WeightedInstancesHandler
Removes attributes of a given type.

Valid options are:

     -T <nominal|numeric|string|date|relational>
      Attribute type to delete. Valid options are "nominal",
      "numeric", "string", "date" and "relational".
      (default "string")

     -V
      Invert matching sense (i.e. only keep specified columns)

Version:
  $Revision: 15310 $
Author:
  Richard Kirkby (rkirkby@cs.waikato.ac.nz)
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Tag[]`
  `TAGS_ATTRIBUTETYPE`
  Tag allowing selection of attribute type to delete

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RemoveType()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `attributeTypeTipText()`
  Returns the tip text for this property
  `boolean`
  `batchFinished()`
  Signify that this batch of input to the filter is finished.
  `SelectedTag`
  `getAttributeType()`
  Gets the attribute type to be deleted by the filter.
  `Capabilities`
  `getCapabilities()`
  Returns the Capabilities of this filter.
  `boolean`
  `getInvertSelection()`
  Get whether the supplied columns are to be removed or kept
  `String[]`
  `getOptions()`
  Gets the current settings of the filter.
  `String`
  `getRevision()`
  Returns the revision string.
  `String`
  `globalInfo()`
  Returns a string describing this filter
  `boolean`
  `input(Instance instance)`
  Input an instance for filtering.
  `String`
  `invertSelectionTipText()`
  Returns the tip text for this property
  `boolean`
  `isOutputFormatDefined()`
  Returns whether the output format is ready to be collected
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options.
  `static void`
  `main(String[] argv)`
  Main method for testing this class.
  `int`
  `numPendingOutput()`
  Returns the number of instances pending output
  `Instance`
  `output()`
  Output an instance after filtering and remove from the output queue.
  `Instance`
  `outputPeek()`
  Output an instance after filtering but do not remove from the output queue.
  `void`
  `setAttributeType(SelectedTag type)`
  Sets the attribute type to be deleted by the filter.
  `boolean`
  `setInputFormat(Instances instanceInfo)`
  Sets the format of the input instances.
  `void`
  `setInvertSelection(boolean invert)`
  Set whether selected columns should be removed or kept.
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.

  ### Methods inherited from class weka.filters.Filter

  `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### TAGS_ATTRIBUTETYPE

    public static final Tag[] TAGS_ATTRIBUTETYPE
    Tag allowing selection of attribute type to delete

- ## Constructor Details

  - ### RemoveType

    public RemoveType()

- ## Method Details

  - ### getCapabilities

    public Capabilities getCapabilities()
    Returns the Capabilities of this filter.
    Specified by:
      `getCapabilities` in interface `CapabilitiesHandler`
    Overrides:
      `getCapabilities` in class `Filter`
    Returns:
      the capabilities of this object
    See Also:
      - `Capabilities`

  - ### setInputFormat

    public boolean setInputFormat(Instances instanceInfo) throws Exception
    Sets the format of the input instances.
    Overrides:
      `setInputFormat` in class `Filter`
    Parameters:
      `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
    Returns:
      true if the outputFormat may be collected immediately
    Throws:
      `Exception` - if the inputFormat can't be set successfully

  - ### input

    public boolean input(Instance instance)
    Input an instance for filtering.
    Overrides:
      `input` in class `Filter`
    Parameters:
      `instance` - the input instance
    Returns:
      true if the filtered instance may now be collected with output().

  - ### batchFinished

    public boolean batchFinished() throws Exception
    Signify that this batch of input to the filter is finished.
    Overrides:
      `batchFinished` in class `Filter`
    Returns:
      true if there are instances pending output
    Throws:
      `Exception` - if something goes wrong

  - ### output

    public Instance output()
    Output an instance after filtering and remove from the output queue.
    Overrides:
      `output` in class `Filter`
    Returns:
      the instance that has most recently been filtered (or null if the queue is empty).

  - ### outputPeek

    public Instance outputPeek()
    Output an instance after filtering but do not remove from the output queue.
    Overrides:
      `outputPeek` in class `Filter`
    Returns:
      the instance that has most recently been filtered (or null if the queue is empty).

  - ### numPendingOutput

    public int numPendingOutput()
    Returns the number of instances pending output
    Overrides:
      `numPendingOutput` in class `Filter`
    Returns:
      the number of instances pending output

  - ### isOutputFormatDefined

    public boolean isOutputFormatDefined()
    Returns whether the output format is ready to be collected
    Overrides:
      `isOutputFormatDefined` in class `Filter`
    Returns:
      true if the output format is set

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options.
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `Filter`
    Returns:
      an enumeration of all the available options.

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options.

    Valid options are:

         -T <nominal|numeric|string|date|relational>
          Attribute type to delete. Valid options are "nominal",
          "numeric", "string", "date" and "relational".
          (default "string")

         -V
          Invert matching sense (i.e. only keep specified columns)

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `Filter`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of the filter.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `Filter`
    Returns:
      an array of strings suitable for passing to setOptions

  - ### globalInfo

    public String globalInfo()
    Returns a string describing this filter
    Returns:
      a description of the filter suitable for displaying in the explorer/experimenter gui

  - ### attributeTypeTipText

    public String attributeTypeTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### setAttributeType

    public void setAttributeType(SelectedTag type)
    Sets the attribute type to be deleted by the filter.
    Parameters:
      `type` - a TAGS_ATTRIBUTETYPE of the new type the filter should delete

  - ### getAttributeType

    public SelectedTag getAttributeType()
    Gets the attribute type to be deleted by the filter.
    Returns:
      the attribute type as a selected tag TAGS_ATTRIBUTETYPE

  - ### invertSelectionTipText

    public String invertSelectionTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getInvertSelection

    public boolean getInvertSelection()
    Get whether the supplied columns are to be removed or kept
    Returns:
      true if the supplied columns will be kept

  - ### setInvertSelection

    public void setInvertSelection(boolean invert)
    Set whether selected columns should be removed or kept. If true the selected columns are kept and unselected columns are deleted. If false selected columns are deleted and unselected columns are kept.
    Parameters:
      `invert` - the new invert setting

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Overrides:
      `getRevision` in class `Filter`
    Returns:
      the revision

  - ### main

    public static void main(String[] argv)
    Main method for testing this class.
    Parameters:
      `argv` - should contain arguments to the filter: use -h for help